package com.link.core.objlocalhandle.kafka;

import com.lmax.disruptor.RingBuffer;

public class KafkaEventProducer {
   private final RingBuffer<KafkaEvent> ringBuffer;

   public KafkaEventProducer(RingBuffer<KafkaEvent> ringBuffer) {
      this.ringBuffer = ringBuffer;
   }

   public void onData(KafkaEvent data) {
      long sequence = this.ringBuffer.next();

      try {
         KafkaEvent event = (KafkaEvent)this.ringBuffer.get(sequence);
         event.setKafkaEvent(data.getKafkaEvent());
         event.setKafkaPartition(data.getKafkaPartition());
         event.setKafkaTopic(data.getKafkaTopic());
         event.setKafkaKey(data.getKafkaKey());
      } finally {
         this.ringBuffer.publish(sequence);
      }

   }
}
